=begin
(c) TIG 2013
All rights reserved.
THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES; 
INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
FITNESS FOR A PARTICULAR PURPOSE.
Usage: in code TIG::Uniquify.new() on a Selection.
OR use Plugins/Context-menu item 'Uniquify'...
All selected groups/components, and any nested groups/components are 
made-unique.
It is one step undoable.
Donations:[paypal]3675634[/paypal]   
Version:
1.0 20130215 First Release.
=end
require('sketchup.rb')
module TIG
  class TIG::Uniquify
	def initialize(a=nil)
	  r=a
	  m=Sketchup.active_model
	  m.start_operation('Uniquify') unless r
	  a=m.selection.to_a unless a && a.is_a?(Array)
	  a.each{|e|
		if e.is_a?(Sketchup::ComponentInstance)
		    e.definition.instances.each{|i|
				i.make_unique
				es=i.definition.entities.to_a.select{|ee|
					ee.is_a?(Sketchup::ComponentInstance) || ee.is_a?(Sketchup::Group)
				}
				TIG::Uniquify.new(es)if es[0]
			} if e.definition.instances[1]
		elsif e.is_a?(Sketchup::Group)
		    e.entities.parent.instances.each{|i|
				i.make_unique
				es=i.definition.entities.to_a.select{|ee|
					ee.is_a?(Sketchup::ComponentInstance) || ee.is_a?(Sketchup::Group)
				}
				TIG::Uniquify.new(es)if es[0]
			} if e.entities.parent.instances[1]
		end
	  }
	  m.commit_operation unless r
	end
  end#class
	unless file_loaded?(__FILE__)
		UI.menu("Plugins").add_item("Uniquify"){TIG::Uniquify.new()}
		UI.add_context_menu_handler{|menu|
			menu.add_item("Uniquify"){TIG::Uniquify.new()}
		}
	end
	file_loaded(__FILE__)
end#module
